#pragma once

#include "CoreMinimal.h"
#include "StatusEffect.h"
#include "ViewInRangeAurasToOriginatingPlayerStatusEffect.generated.h"

class AActor;

UCLASS(Blueprintable, EditInlineNew, meta=(BlueprintSpawnableComponent))
class DBDCOMPETENCE_API UViewInRangeAurasToOriginatingPlayerStatusEffect : public UStatusEffect
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Replicated, meta=(AllowPrivateAccess=true))
	float _auraDuration;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Replicated, meta=(AllowPrivateAccess=true))
	float _rangeFromOriginatingPlayer;

	UPROPERTY(EditInstanceOnly, Transient)
	TArray<TWeakObjectPtr<AActor>> _actorsWithActiveOutlines;

public:
	virtual void GetLifetimeReplicatedProps(TArray<FLifetimeProperty>& OutLifetimeProps) const override;

public:
	UViewInRangeAurasToOriginatingPlayerStatusEffect();
};

FORCEINLINE uint32 GetTypeHash(const UViewInRangeAurasToOriginatingPlayerStatusEffect) { return 0; }
